//
// Include
//

#include "NSFileManager+Custom.h"

#include <Foundation/NSProcessInfo.h>
#include <Foundation/NSScanner.h>

//
// Define
//

//
// Typedef
//

//
// Public
//

//
// Private
//

//
// Private Interface
//

//
// Prototype
//

/***************************************************************************/

@implementation NSFileManager (Custom)

/**
 * Scans the <code>PATH</code> environment variable for aFilename and
 * returns the full path, or nil if aFilename cannot be found.
 *
 */

- (NSString *) locateExecutable: (NSString *) aFilename
{
  NSString
    *fullPath = nil;
  
  {
    NSDictionary
      *environment = nil;
    NSString
      *path = nil;
    NSScanner
      *pathScanner;
    BOOL
      found = NO;
    
    environment = [[NSProcessInfo processInfo] environment];
    path = [environment objectForKey: @"PATH"];
    
    pathScanner = [NSScanner scannerWithString: path];
    
    while( ! [pathScanner isAtEnd] && ! found )
    {
      NSString
        *directory = nil;
      BOOL
        isScanned;
      
      isScanned = [pathScanner scanUpToString: @":"
                                   intoString: &directory];
      
      [pathScanner scanString: @":" intoString: NULL];
      
      fullPath = [directory stringByAppendingFormat: @"/%@", aFilename];
      
      found = [self fileExistsAtPath: fullPath];
    }
    
    if( ! found )
      fullPath = nil;
  }
  
  //
  // That's it
  //
  
  return fullPath;
}

@end

/*
** End of File.
**
****************************************************************************/
